//+------------------------------------------------------------------+
//|                                                         $OTF.mq4 |
//|                           Optimal Tracking Filter by John Ehlers |
//+------------------------------------------------------------------+
#property copyright "Vladimir"
#property link      "favorit_box@inbox.ru"

#property indicator_chart_window
//---- indicator settings
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_width1 2
//---- input parameters
extern int       period=15;
extern int   count_bars=1000;

double Value1[],Value2[],Value3[],Price[],SC;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);

   SetIndexBuffer(0,Value3);
   SetIndexDrawBegin(0,50);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,Value2);
   SetIndexBuffer(2,Value1);
   SetIndexBuffer(3,Price);

   SetIndexLabel(0,"OTF");

   SC=2.0/(period+1);   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i,bar=count_bars;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   double alpha,lambda;
//********************************************************************************************
   for (i = limit; i >= 0; i--) 
      {
      Price[i]=(High[i]+Low[i])/2.0;
      }
   for (i = limit; i >= 0; i--) 
      {
      Value1[i]=SC*(Price[i]-Price[i+1])+4*SC*Value1[i+1];
      Value2[i]=SC*(High[i]-Low[i])+4*SC*Value2[i+1];
      }      
   for (i = limit; i >= 0; i--) 
      {
      if(Value2[i]< Point)Value2[i]= Point;else lambda=MathAbs(Value1[i]/Value2[i]);
   
      alpha=(-lambda*lambda+MathSqrt(lambda*lambda*lambda*lambda+16.0*lambda*lambda))/8.0;

      Value3[i]=alpha*Price[i]+(1.0-alpha)*Value3[i+1];
      }
//********************************************************************************************
   return(0);
  }

